/*
 *  Copyright 2010 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.odf.button');

org.ametys.odf.button.EditCatalogButton = function(id, configuration, pluginName) 
{
	org.ametys.odf.button.EditCatalogButton.superclass.constructor.call(this, id, configuration, pluginName);
};

Ext.extend(org.ametys.odf.button.EditCatalogButton, org.ametys.cms.ribbon.button.SmartContentButton, {});

org.ametys.odf.button.EditCatalogButton.prototype.configurationChanged = function(params)
{
	this.getElements().each(function(element) { element.stopRefreshing(); });

	var tooltip = this._handlingMultiple("", "allright", params);
	
	this.contents = [];
	var count = parseInt(params["allright-content-size"]);
	if (count > 0)
	{
		for (var i=0; i < count; i++)
		{
			this.contents.push(params["allright-content-" + i + "-id"]);
		}
	}
	
	var hasOneContent = tooltip.length > 0; 
	if (!hasOneContent)
	{
		tooltip += this.getConfiguration()['error-description'];
	}
	
	tooltip = this._handlingMultiple(tooltip, "locked", params);
	tooltip = this._handlingMultiple(tooltip, "noright", params);
	tooltip = this._handlingMultiple(tooltip, "nomodifiable", params);
	tooltip = this._handlingMultiple(tooltip, "workflowaction", params);
	tooltip = this._handlingMultiple(tooltip, "workflowstep", params);
	tooltip = this._handlingMultiple(tooltip, "unmodifiablecatalog", params);
	
	var toggleState = hasOneContent && this.getConfiguration()["enable-toggle"] == "true";
	this.getElements().each(
		function(element) 
		{ 
			element.allowDepress = false;
			element.setDisabled(!hasOneContent);
			element.toggle(toggleState);
			element.actionId = params['workflowaction-content-actionId'];
		}
	);
	
	this.updateTooltip(tooltip);
	this._lastParams = params;
}


